import { Component, OnInit } from '@angular/core';
import { UntypedFormBuilder, Validators  } from '@angular/forms';
import { ActivatedRoute, Router } from '@angular/router';
import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Kompetenz } from '../kompetenz';
import { KompetenzService } from '../services/kompetenz.service';
import { Observable } from 'rxjs';

@Component({
  selector: 'app-edit-kompetenz',
  templateUrl: './edit-kompetenz.component.html',
  styleUrls: ['./edit-kompetenz.component.css']
})

export class EditKompetenzComponent implements OnInit {

  public editForm: any;
  public aktKompetenzId: any;
  public aktkompetenz?: Kompetenz;
  headers: HttpHeaders = new HttpHeaders()
                  .set('Accept', 'application/json');

  constructor(
    private formbuilder: UntypedFormBuilder,
    private router: Router,
    private kompetenzservice: KompetenzService,
    private activatedRoute: ActivatedRoute,
    private http: HttpClient,
  ) 
  { 
    this.editForm = this.formbuilder.group({
      competenceid: [],
      competence: ['', Validators.required],
      competencedescription: ['', Validators.required ],
      dauer: ['']
    })
  }

  ngOnInit(): void {
    this.aktKompetenzId = this.activatedRoute.snapshot.params['id'];

    if (this.aktKompetenzId > 0) {
      this.kompetenzservice.getSingleKompetenz(this.aktKompetenzId).subscribe((
        (data: any) => {
          // console.log(data);
          this.editForm.patchValue(data);
        }
      ))
    }
  }
  onEdit(): void {

  }
  onCancel(): void {
    this.router.navigate(['/kompetenz']);
  }
}
