import { AfterViewInit, Component, OnInit, ViewChild } from '@angular/core';
import { Lehrling } from '../lehrling';
import { LehrlingService } from '../services/lehrling.service';
import { Profession } from '../Profession';
import { ProfessionService } from '../services/profession.service';
import { MatSelect } from '@angular/material/select';
import { MatSelectModule } from '@angular/material/select';
import { MatTableDataSource, MatTableModule } from '@angular/material/table';
import { MatPaginator } from '@angular/material/paginator';
import { FormBuilder, Validators } from '@angular/forms';
import { SelectionModel } from '@angular/cdk/collections';

@Component({
  selector: 'app-lehrling2beruf',
  templateUrl: './lehrling2beruf.component.html',
  styleUrls: ['./lehrling2beruf.component.css']
})
export class Lehrling2berufComponent implements OnInit, AfterViewInit {

  public lehrlinge: any;
  public dsLehrlinge?: MatTableDataSource<Lehrling>;
  public profession: any;
  public aktprofessionid: any;
 //  public dsProfession?: MatTableDataSource<Profession>;
  selectedLehrling: Lehrling | null = null;
  public displayedColumns: any;
  public row: any;
  selected: Profession | null = null;

  @ViewChild(MatPaginator) paginator?: MatPaginator;
  
  constructor(private Lehrlinge: LehrlingService, 
              private professions: ProfessionService,
              public fb: FormBuilder) { }

  ProfessionFormGroup = this.fb.group({
    professionname: ['', [Validators.required]],
  });

  ngOnInit(): void {
    this.displayedColumns = ["select", "apprenticeid", "firstname", "lastname", "groupname"];
    this.Lehrlinge.getLehrlinge().subscribe(
      (
        data: any) => {
       //  console.log(data);
        this.lehrlinge = data.apprentice;
        this.dsLehrlinge = this.lehrlinge;
        this.dsLehrlinge = new MatTableDataSource<Lehrling>(this.lehrlinge);
        this.dsLehrlinge.paginator = this.paginator;
        
    });
    this.professions.getProfessionList().subscribe(
      (
        data: any) => {
        //   console.log(data);
          this.profession = data;
        }
      )
  }

  ngAfterViewInit() {
    this.dsLehrlinge = new MatTableDataSource<Lehrling>(this.lehrlinge);
    this.dsLehrlinge.paginator = this.paginator;
  } 

  selection = new SelectionModel<Lehrling>(true, []);

  /** Whether the number of selected elements matches the total number of rows. */
  isAllSelected() {
    const numSelected = this.selection.selected.length;
    const numRows = this.dsLehrlinge.data.length;
    return numSelected === numRows;
  }

  wirdausgewaehlt(zeile: any) {
      console.log(zeile);
  }

  /** Selects all rows if they are not all selected; otherwise clear selection. */
  masterToggle() {
    this.isAllSelected() ?
        this.selection.clear() :
        this.dsLehrlinge.data.forEach(row => this.selection.select(row));
  }
  changeProfession(e: any) {
    // console.log(e);
      this.aktprofessionid = e.target.value;
  }

  TNspeichern() {
    let selectedTNIds: number[] = [];
    for (let item of this.selection.selected) {
      console.log(item.apprenticeid);
      selectedTNIds.push(item.apprenticeid);
    }
  }
}
